import { CreateUserBody, UserInfo } from '@core';
import { Services } from '../app';
import { User, UserWithPassword } from '../entities/user';

export function Create(
  services: Services,
): (tracker: string, raw: CreateUserBody) => Promise<UserInfo> {
  const { userModel } = services;

  return async (tracker, raw) => {
    const user = await userModel.create(tracker, new UserWithPassword(raw));
    return user.Info();
  };
}

export function Read(
  services: Services,
): (tracker: string, uuid: string) => Promise<UserInfo> {
  const { userModel } = services;

  return async (tracker, uuid) => {
    const user = await userModel.read(tracker, uuid);
    return user.Info();
  };
}
