import { EntityInfo } from './entity';

export type UserInfo = {
  uuid: string;
  name: string;
};

export type UserInfoWithPassword = {
  password: string;
} & UserInfo;

export type User = UserInfo & EntityInfo;

export type UserWithPassword = UserInfoWithPassword & EntityInfo;

export type CreateUserBody = {
  name: string;
  password: string;
};

export type LoginUserBody = CreateUserBody;

export type UserCtor = Partial<User>;

export type UserWithPasswordCtor = Partial<UserWithPassword>;
